#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	public enum MicroEnum
	{
		FullStep,
		TwoXstep,
		FourXstep,
		EightXstep
	}
	#region PluginInfo
	[PluginInfo(Name = "keyboard2COMMAND", Category = "String", Version = "0.1", Help = "Take a keypress and translate to a commande for LK.DRM2", Tags = "")]
	#endregion PluginInfo
	public class C0_1Stringkeyboard2COMMANDNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("KEYBOARD in", DefaultString = "a")]													//		 IsSingle = true
		ISpread<string> FInput;
		[Input("Xfloat", DefaultValue = 00.00)]															//XXX
		ISpread<float> FInput2;
		[Input("Yfloat", DefaultValue = 00.00)]															//YYY
		ISpread<float> FInput3;
		[Input("Pen UP", DefaultValue = 1 , IsSingle = true)]										//PUP
		IDiffSpread<bool> FInput4;
		[Input("VAL/2XVAL", DefaultValue = 0 , IsSingle = true)]									//COO
		ISpread<bool> FInput5;
		[Input("ACCEL/CONST", DefaultValue = 1 , IsSingle = true)]									//ACC//BAC
		ISpread<bool> FInput6;
		[Input("speed", DefaultValue = 700 , IsSingle = true)]										//ACC//SPD
		ISpread<int> FInput7;
		[Input("acceleration", DefaultValue = 3000 , IsSingle = true)]								//ACC//ACC
		ISpread<int> FInput8;
		[Input("NightSpeed", DefaultValue = 50 , IsSingle = true)]									//ACC//NSP
		ISpread<int> FInput9;
		[Input("Microstep", DefaultEnumEntry = "FullStep" , IsSingle = true)]									//MIC
		IDiffSpread<MicroEnum> FInput10;
		[Input("LastCoordonateSave", DefaultValue = 0, IsBang = true , IsSingle = true)]			//LAS
		ISpread<bool> FInput11;
		[Input("GoHome", DefaultValue = 0, IsBang = true , IsSingle = true)]						//HOM
		ISpread<bool> FInput12;
		[Input("GoLastCoordonate", DefaultValue = 0 , IsBang = true , IsSingle = true)]				//LAG
		ISpread<bool> FInput13;
		[Input("GoOutsidePapper", DefaultValue = 0, IsBang = true , IsSingle = true)]				//OUT
		ISpread<bool> FInput14;
		[Input("FineStep", DefaultValue = 0 , IsSingle = true)]										//NUM
		ISpread<bool> FInput15;
		[Input("SetFineNumberOfStep", DefaultValue = 10 , IsSingle = true)]							//NUM//NBF
		ISpread<int> FInput15b;
		[Input("SetNumberOfStep", DefaultValue = 200 , IsSingle = true)]							//NUM3//NMB
		ISpread<int> FInput15c;
		[Input("Day/Night", DefaultValue = 1 , IsSingle = true)]									//DAY
		ISpread<bool> FInput16;
		[Input("GetCoordonate(Relative)", DefaultValue = 0, IsBang = true , IsSingle = true)]		//GCO
		ISpread<bool> FInput17;
		[Input("ForceTopLeft Save/Call/Empty", DefaultValue = 0 , IsSingle = true)]					//MTL
		ISpread<int> FInput18;
		[Input("ForceTopRight Save/Call/Empty", DefaultValue = 0 , IsSingle = true)]				//MTR
		ISpread<int> FInput19;
		[Input("PapperTopLeftSave", DefaultValue = 0, IsBang = true , IsSingle = true)]				//PTL
		ISpread<bool> FInput20;
		[Input("PapperTopRight Save/get/empty", DefaultValue = 0 , IsSingle = true)]				//PTR
		ISpread<int> FInput21;
		[Input("PapperBottom Save/get/empty", DefaultValue = 0 , IsSingle = true)]					//PBT
		ISpread<int> FInput22;
		[Input("END", DefaultValue = 0, IsBang = true , IsSingle = true)]							//END
		ISpread<bool> FInput23;
		
		[Output("COMMAND out")]
		ISpread<string> FOutput;

		ISpread<bool> PENUP;
		
		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			

			for (int i = 0; i < SpreadMax; i++)
				
				//FOutput[i] = FInput[i].Replace("e", "RWL");
				//FOutput[i] = FInput[i].Replace("r", "UPP");
				if(FInput[i] == "E"){
					FOutput[i] = "RWL;";
				}
				else if(FInput[i] == "R"){
					FOutput[i] = "UPP;";
				}
				else if(FInput[i] == "T"){
					FOutput[i] = "RWR;";
				}
				else if(FInput[i] == "D"){
					FOutput[i] = "LLL;";
				}
				else if(FInput[i] == "G"){
					FOutput[i] = "RRR;";
				}
				else if(FInput[i] == "C"){
					FOutput[i] = "FFR;";
				}
				else if(FInput[i] == "V"){
					FOutput[i] = "DWN;";
				}
				else if(FInput[i] == "B"){
					FOutput[i] = "FFL;";
				}
				else if (FInput10.IsChanged){
					FOutput[i] = "MIC" + (Enum.GetName(typeof(MicroEnum), FInput10[i]) + ";");
				}
				else if (FInput4.IsChanged){
					FOutput[i] = "PUP" + (FInput4[i] + ";");
				}
				else{FOutput[i] = "\0";}
				//else if(FInput[i] == "F"){
				//	FOutput[i] = "STO";
				//}
			
		}
		
	}
}