#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "KeyboardToCOM", 
	            Category = "String",
	            Help = "Basic template with one string in/out",
	            Tags = "")]
	#endregion PluginInfo
	public class C0_1StringkeyboardCOMNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("KEYBOARD in", DefaultString = "a")]
		ISpread<string> FInput;

		[Output("COMMAND out")]
		ISpread<string> FOutput;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;

			for (int i = 0; i < SpreadMax; i++)
				//FOutput[i] = FInput[i].Replace("e", "RWL");
				//FOutput[i] = FInput[i].Replace("r", "UPP");
				if(FInput[i] == "e"){
					FOutput[i] = "RWL";
				}
				else if(FInput[i] == "r"){
					FOutput[i] = "UPP";
				}
				else if(FInput[i] == "t"){
					FOutput[i] = "RWR";
				}
				else if(FInput[i] == "d"){
					FOutput[i] = "LLL";
				}
				else if(FInput[i] == "g"){
					FOutput[i] = "RRR";
				}
				else if(FInput[i] == "c"){
					FOutput[i] = "FFR";
				}
				else if(FInput[i] == "v"){
					FOutput[i] = "DWN";
				}
				else if(FInput[i] == "b"){
					FOutput[i] = "FFL";
				}
			
		}
		
	}
}
				
			//FLogger.Log(LogType.Debug, "Logging to Renderer (TTY)");
		
	

